diff --git a/hw/misc/trace-events b/hw/misc/trace-events
index 0cc556c..71c8e3b 100644
--- a/hw/misc/trace-events
+++ b/hw/misc/trace-events
@@ -1,13 +1,13 @@
 # See docs/tracing.txt for syntax documentation.

 # hw/misc/eccmemctl.c
-ecc_mem_writel_mer(uint32_t val) "Write memory enable %08x"
-ecc_mem_writel_mdr(uint32_t val) "Write memory delay %08x"
-ecc_mem_writel_mfsr(uint32_t val) "Write memory fault status %08x"
-ecc_mem_writel_vcr(uint32_t val) "Write slot configuration %08x"
-ecc_mem_writel_dr(uint32_t val) "Write diagnostic %08x"
-ecc_mem_writel_ecr0(uint32_t val) "Write event count 1 %08x"
-ecc_mem_writel_ecr1(uint32_t val) "Write event count 2 %08x"
+ecc_mem_writel_mer(uint64_t val) "Write memory enable %08" PRIx64
+ecc_mem_writel_mdr(uint64_t val) "Write memory delay %08" PRIx64
+ecc_mem_writel_mfsr(uint64_t val) "Write memory fault status %08" PRIx64
+ecc_mem_writel_vcr(uint64_t val) "Write slot configuration %08" PRIx64
+ecc_mem_writel_dr(uint64_t val) "Write diagnostic %08" PRIx64
+ecc_mem_writel_ecr0(uint64_t val) "Write event count 1 %08" PRIx64
+ecc_mem_writel_ecr1(uint64_t val) "Write event count 2 %08" PRIx64
 ecc_mem_readl_mer(uint32_t ret) "Read memory enable %08x"
 ecc_mem_readl_mdr(uint32_t ret) "Read memory delay %08x"
 ecc_mem_readl_mfsr(uint32_t ret) "Read memory fault status %08x"
@@ -17,39 +17,39 @@ ecc_mem_readl_mfar1(uint32_t ret) "Read memory fault address 1 %08x"
 ecc_mem_readl_dr(uint32_t ret) "Read diagnostic %08x"
 ecc_mem_readl_ecr0(uint32_t ret) "Read event count 1 %08x"
 ecc_mem_readl_ecr1(uint32_t ret) "Read event count 2 %08x"
-ecc_diag_mem_writeb(uint64_t addr, uint32_t val) "Write diagnostic %"PRId64" = %02x"
+ecc_diag_mem_writeb(uint64_t addr, uint64_t val) "Write diagnostic %"PRId64" = %02" PRIx64
 ecc_diag_mem_readb(uint64_t addr, uint32_t ret) "Read diagnostic %"PRId64"= %02x"

 # hw/misc/slavio_misc.c
 slavio_misc_update_irq_raise(void) "Raise IRQ"
 slavio_misc_update_irq_lower(void) "Lower IRQ"
 slavio_set_power_fail(int power_failing, uint8_t config) "Power fail: %d, config: %d"
-slavio_cfg_mem_writeb(uint32_t val) "Write config %02x"
+slavio_cfg_mem_writeb(uint64_t val) "Write config %02" PRIx64
 slavio_cfg_mem_readb(uint32_t ret) "Read config %02x"
-slavio_diag_mem_writeb(uint32_t val) "Write diag %02x"
+slavio_diag_mem_writeb(uint64_t val) "Write diag %02" PRIx64
 slavio_diag_mem_readb(uint32_t ret) "Read diag %02x"
-slavio_mdm_mem_writeb(uint32_t val) "Write modem control %02x"
+slavio_mdm_mem_writeb(uint64_t val) "Write modem control %02" PRIx64
 slavio_mdm_mem_readb(uint32_t ret) "Read modem control %02x"
-slavio_aux1_mem_writeb(uint32_t val) "Write aux1 %02x"
+slavio_aux1_mem_writeb(uint64_t val) "Write aux1 %02" PRIx64
 slavio_aux1_mem_readb(uint32_t ret) "Read aux1 %02x"
-slavio_aux2_mem_writeb(uint32_t val) "Write aux2 %02x"
+slavio_aux2_mem_writeb(uint64_t val) "Write aux2 %02" PRIx64
 slavio_aux2_mem_readb(uint32_t ret) "Read aux2 %02x"
-apc_mem_writeb(uint32_t val) "Write power management %02x"
+apc_mem_writeb(uint64_t val) "Write power management %02" PRIx64
 apc_mem_readb(uint32_t ret) "Read power management %02x"
-slavio_sysctrl_mem_writel(uint32_t val) "Write system control %08x"
+slavio_sysctrl_mem_writel(uint64_t val) "Write system control %08" PRIx64
 slavio_sysctrl_mem_readl(uint32_t ret) "Read system control %08x"
-slavio_led_mem_writew(uint32_t val) "Write diagnostic LED %04x"
+slavio_led_mem_writew(uint64_t val) "Write diagnostic LED %04" PRIx64
 slavio_led_mem_readw(uint32_t ret) "Read diagnostic LED %04x"

 # hw/misc/milkymist-hpdmc.c
-milkymist_hpdmc_memory_read(uint32_t addr, uint32_t value) "addr=%08x value=%08x"
-milkymist_hpdmc_memory_write(uint32_t addr, uint32_t value) "addr=%08x value=%08x"
+milkymist_hpdmc_memory_read(hwaddr addr, uint32_t value) "addr=%08" HWADDR_PRIx " value=%08x"
+milkymist_hpdmc_memory_write(hwaddr addr, uint64_t value) "addr=%08" HWADDR_PRIx " value=%08" PRIx64

 # hw/misc/milkymist-pfpu.c
-milkymist_pfpu_memory_read(uint32_t addr, uint32_t value) "addr %08x value %08x"
-milkymist_pfpu_memory_write(uint32_t addr, uint32_t value) "addr %08x value %08x"
-milkymist_pfpu_vectout(uint32_t a, uint32_t b, uint32_t dma_ptr) "a %08x b %08x dma_ptr %08x"
+milkymist_pfpu_memory_read(hwaddr addr, uint32_t value) "addr %08" HWADDR_PRIx " value %08x"
+milkymist_pfpu_memory_write(hwaddr addr, uint64_t value) "addr %08" HWADDR_PRIx " value %08" PRIx64
+milkymist_pfpu_vectout(uint32_t a, uint32_t b, hwaddr dma_ptr) "a %08x b %08x dma_ptr %08" HWADDR_PRIx
 milkymist_pfpu_pulse_irq(void) "Pulse IRQ"

 # hw/misc/aspeed_scu.c
-aspeed_scu_write(uint64_t offset, unsigned size, uint32_t data) "To 0x%" PRIx64 " of size %u: 0x%" PRIx32
+aspeed_scu_write(uint64_t offset, unsigned size, uint64_t data) "To 0x%" PRIx64 " of size %u: 0x%" PRIx64